#####################################################################
#
#     TCL SMS library 0.2
#    by Gerhard Reithofer
# mail: gerhardr@tech-edv.co.at
#
# Techn. EDV Reithofer, Technical software solutions
# http://members.aon.at/tech-edv
# http://www.computer.privateweb.at/tech-edv
#
# Information mostly retrieved from:
#
#   Developer's Guide:
#    SMS with the SMS PDU-mode
#  Version 1.2 (30.07.97) by Siemens AG
# found at: http://www.min.at/prinz/s25/smspdu.pdf
#
#  ... you will find many, many, many usefult things at the
#      (M)obile (I)nformation (N)etwork
# site by Richard Prinz Richard.Prinz@min.at
#
# ... and NOBI's real great GSM site
#              http://www.nobbi.com/
#
# WARNING - WARNING - WARNING - WARNING - WARNING - WARNING - WARNING
# Many of these functions are untested!
# Yor will loose information if working with this software components!
# DISCLAIMER
# In no case I will be liable for any loss of information or
# any other misfortune, calamity, disaster ... which may be caused
# using this software or components of it!
# WARNING - WARNING - WARNING - WARNING - WARNING - WARNING - WARNING
#

set SMS_MSG_MODE(REC_UNREAD) 0
set SMS_MSG_MODE(REC_READ)   1
set SMS_MSG_MODE(STO_UNSENT) 2
set SMS_MSG_MODE(STO_SENT)   3
set SMS_MSG_MODE(ALL)        4

set SMS_MSG_STAT($SMS_MSG_MODE(REC_UNREAD)) "empfangen, ungelesen"
set SMS_MSG_STAT($SMS_MSG_MODE(REC_READ))   "empfangen, gelesen"
set SMS_MSG_STAT($SMS_MSG_MODE(STO_UNSENT)) "gespeichert, ungesendet"
set SMS_MSG_STAT($SMS_MSG_MODE(STO_SENT))   "gespeichert, gesendet"
set SMS_MSG_STAT($SMS_MSG_MODE(ALL))        "alle Meldungen"

set SMS_MSG_VALID(NONE)     0 
set SMS_MSG_VALID(RESERVED) 1
set SMS_MSG_VALID(RELATIVE) 2
set SMS_MSG_VALID(ABSOLUTE) 3

set SMS_MSG_VP_VALUE($SMS_MSG_VALID(NONE))     "keine"
set SMS_MSG_VP_VALUE($SMS_MSG_VALID(RESERVED)) "* Fehler *"
set SMS_MSG_VP_VALUE($SMS_MSG_VALID(RELATIVE)) \
  [list "%d Minuten" "%d Stunden" "%d Tage" "%d Wochen"]
set SMS_MSG_VP_VALUE($SMS_MSG_VALID(ABSOLUTE)) "bis %s"

##############################################
#                                            #
#  ########################################  #
#  #                                      #  #
#  #  Implemented SMS standard features   #  #
#  #                                      #  #
#  ########################################  #
#                                            #
##############################################

global array SMS_FLAGS PDU_TYPE PDU_DEF 

##############################################
#
# SMS PDU type byte - DELIVER mode
# 
# Bit 7 - Reply Path 
set PDU_DEF(RP)   0
# Bit 6 - User Data Header Indicator
set PDU_DEF(UDHI) 0
# Bit 5 - Status Report Requesr
set PDU_DEF(SRR)  0
# Bit 4+3 - Valid Period Flag - no value
set PDU_DEF(VPF)  0
# Bit 2 - Reject Duplicate
set PDU_DEF(RD)  0
# Bit 1+0 - Message Type Indicator (default is SMS-SUBMIT)
set PDU_DEF(MTI)  1
##############################################
#
# SMS FLAGS default - DELIVER mode
#
##############################################
# 
# Specify SMS -> fromphone
set SMS_DEF(SCA) "00"
# Extract PDU flag  later
# set SMS_DEF(PDU) [set_pdu_flags -1]
# Message reference -> 00-FF 
set SMS_DEF(MR) "00"
# Destination address (phone number)
# set SMS_DEF(DA) [phone2pdu $pnum]
# Protocol IDentifier -> PDU has tobe treted as sms
set SMS_DEF(PID) "00"
# Data Coding Scheme -> default 7-bit coding 
set SMS_DEF(DCS) "00"
# Validy Period flag -> no value given (PDU_DEF(VPF) must be 0)
set SMS_DEF(VP) "" 

#
# Character map found at:
#     http://www.dreamfabric.com/sms/default_alphabet.html
# Many thanks to the dream team:
#   Joakim Eriksson, Niclas Finne, Lars Olsson, 
#   Lars Petterson, Karl-Petter kesson, Erik Klintskog 
#
# list 0 - standad char mapping from GSM 03.38. to ISO-8859-1
# list 1 - char after escape GSM
# list 3 - corr. ISO char 
#
# 0 - means unsupoorted (like greek alphabet, Euro symbol...)
#
set gsm_default_alphabet [list [list \
  64 163  36 165 232 233 250 236 242 199  10 216 248  13 197 229 \
   0  95   0   0   0   0   0   0   0   0   0   0 198 230 223 202 \
  32  33  34  35   0  37  38  39  40  41  42  43  44  45  46  47 \
  48  49  50  51  52  53  54  55  56  57  58  59  60  61  62  63 \
 161  65  66  67  68  69  70  71  72  73  74  75  76  77  78  79 \
  80  81  82  83  84  85  86  87  88  89  90 196 214 209 220 167 \
 191  97  98  99 100 101 102 103 104 105 106 107 108 109 110 111 \
 112 113 114 115 116 117 118 119 120 121 122 228 246 241 252 224]\
  [list 10  20  40  41  47  60  61  62  64 101]\
  [list 12  94 123 125  92  91 126  93 124   0]\
 ]

proc pdu2iso { str } {
  global gsm_default_alphabet
  DebugOut 3 "CALL: pdu2iso $str"

  set notsup " "
  set unknow "?"
  set cmap [lindex $gsm_default_alphabet 0]
  set escp [lindex $gsm_default_alphabet 1]
  set esci [lindex $gsm_default_alphabet 2]
  set rval ""

  set blist {}
  set sl [string length $str]
  for {set i 0} {$i < $sl} {incr i} {
    scan [string index $str $i] "%c" b
    lappend blist $b
  }

  set cnt 0
  set stl [llength $blist]
  while {$cnt < $stl} {
    set inp [lindex $blist $cnt] ; ### nth character
    set map [lindex $cmap $inp]  ; ### mapped value
    switch -- $map {
      -1 { ; ### unknown chacter (not found in cmap) - should never appear!!!
        puts "\007" ; ### HELP!
        append rval $unknow
      }
      0 {  ; ### unsupported character
        append rval $notsup
      }
      27 { ; ### escaped chacter
       set inp [lindex $str [incr cnt]] ; ### fetch next char
       set escidx [lsearch $escp $inp]  ; ### is it a valid escape char?
        if {$escidx == -1} {
          append rval [format "%c" 27]
        } else {
          append rval [lindex $esci $escidx]
        }
      }
      default { ; ### the result directly
        append rval [format "%c" $map]
      }
    }
    incr cnt
  }
  DebugOut 3 "RETURN: pdu2iso $rval"
  return $rval
}

proc iso2pdu { str } {
  global gsm_default_alphabet
  DebugOut 3 "CALL: iso2pdu $str"
  set notsup " "
  set cmap [lindex $gsm_default_alphabet 0]
  set escp [lindex $gsm_default_alphabet 1]
  set esci [lindex $gsm_default_alphabet 2]
  set rval ""
  set sl [string length $str]
  for {set i 0} {$i < $sl} {incr i} {
    scan [string index $str $i] "%c" inp
# puts [format "DEBUG: c\[%d\]=%s, inp=$inp" $i [string index $str $i] $inp]
    set is_esc [lsearch $esci $inp]
    if {$is_esc == -1} {
      set idx [lsearch $cmap $inp]
# puts [format "DEBUG: inp=$inp->idx=$idx cidx=%c" $idx]
      if {$idx == -1} {
        append rval $notsup
      } else {
        append rval [format "%c" $idx]
      }
    } else {
      append rval [format "\x1b%c" [lindex $escp $is_esc]]
    }
  }
  DebugOut 3 "RETURN: iso2pdu $rval"
  return $rval
}

###
### DEBUG function 
###
proc disp_sms_flags { } {
  DebugOut 3 "CALL: disp_sms_flags"
  global SMS_FLAG PDU_TYPE

  if [info exists SMS_FLAG(SCA) ] { puts "SMS_FLAG(SCA) =$SMS_FLAG(SCA)"  }
  if [info exists SMS_FLAG(PDU) ] { puts "SMS_FLAG(PDU) =$SMS_FLAG(PDU)"  }
 
  if [info exists PDU_TYPE(RP)  ] { puts "  PDU_TYPE(RP)  =$PDU_TYPE(RP)"   }
  if [info exists PDU_TYPE(UDHI)] { puts "  PDU_TYPE(UDHI)=$PDU_TYPE(UDHI)" }
  if [info exists PDU_TYPE(SRI) ] { puts "  PDU_TYPE(SRI) =$PDU_TYPE(SRI)"  }
  if [info exists PDU_TYPE(SRR) ] { puts "  PDU_TYPE(SRI) =$PDU_TYPE(SRR)"  }
  if [info exists PDU_TYPE(VPF) ] { puts "  PDU_TYPE(VPF) =$PDU_TYPE(VPF)"  }
  if [info exists PDU_TYPE(MMS) ] { puts "  PDU_TYPE(MMS) =$PDU_TYPE(MMS)"  }
  if [info exists PDU_TYPE(RD)  ] { puts "  PDU_TYPE(RD)  =$PDU_TYPE(RD)"   }
  if [info exists PDU_TYPE(MTI) ] { puts "  PDU_TYPE(MTI) =$PDU_TYPE(MTI)"  }

  if [info exists SMS_FLAG(MR)  ] { puts "SMS_FLAG(MR)  =$SMS_FLAG(MR)"   }
  if [info exists SMS_FLAG(DA)  ] { puts "SMS_FLAG(DA)  =$SMS_FLAG(DA)"   }
  if [info exists SMS_FLAG(OA)  ] { puts "SMS_FLAG(OA)  =$SMS_FLAG(OA)"   }
  if [info exists SMS_FLAG(PID) ] { puts "SMS_FLAG(PID) =$SMS_FLAG(PID)"  }
  if [info exists SMS_FLAG(DCS) ] { puts "SMS_FLAG(DCS) =$SMS_FLAG(DCS)"  }
  if [info exists SMS_FLAG(VP)  ] { puts "SMS_FLAG(VP)  =$SMS_FLAG(VP)"   }
  if [info exists SMS_FLAG(SCTS)] { puts "SMS_FLAG(SCTS)=$SMS_FLAG(SCTS)" }
  if [info exists SMS_FLAG(UDL) ] { puts "SMS_FLAG(UDL) =$SMS_FLAG(UDL)"  }

  DebugOut 3 "RETURN: disp_sms_flags"
}

proc set_pdu_flags { val } {
  global PDU_TYPE PDU_DEF
  DebugOut 3 "CALL: set_pdu_flags $val"

  if {$val == -1} {
##### SUBMIT mode - MS -> SMSC
    # Bit 7 - Reply Path -> 0
    set PDU_TYPE(RP)   $PDU_DEF(RP)
    # Bit 6 - User Data Header Indicator -> 0
    set PDU_TYPE(UDHI) $PDU_DEF(UDHI)
    # Bit 5 - Status Report Request -> 0
    set PDU_TYPE(SRR)  $PDU_DEF(SRR)
    # Bit 4+3 - Valid Period Flag -> see get_vp_value
    set PDU_TYPE(VPF)  $PDU_DEF(VPF)
    # Bit 2 - Reject Duplicate -> 0
    set PDU_TYPE(RD)   $PDU_DEF(RD)
    # Bit 1+0 - Message Type Indicator - must be "01"
    set PDU_TYPE(MTI)  $PDU_DEF(MTI)
    set val [expr ($PDU_TYPE(RP)  <<7) | \
                  ($PDU_TYPE(UDHI)<<6) | \
                  ($PDU_TYPE(SRR) <<5) | \
                  ($PDU_TYPE(VPF) <<3) | \
                  ($PDU_TYPE(RD)  <<2) | \
                   $PDU_TYPE(MTI)]
# disp_sms_flags
# puts "set_pdu_flag -> $val"
  } else {
##### DELIVER mode SMSC -> MS
    # Bit 7 - Reply Path
    set PDU_TYPE(RP)   [expr ($val & 128) >> 7] 
    # Bit 6 - User Data Header Indicator
    set PDU_TYPE(UDHI) [expr ($val &  64) >> 6]
    # Bit 5 - Statue Report Inidicator
    set PDU_TYPE(SRI)  [expr ($val &  32) >> 5]
    # Bit 4+3 - VPF - should only be of interest at SUBMIT
    set PDU_TYPE(VPF)  [expr ($val &  24) >> 3] 
    # Bit 2 - More Message to Send 
    set PDU_TYPE(MMS)  [expr ($val &   4) >> 2]
    # Bit 1+0 - Message Type Indicator
    set PDU_TYPE(MTI)  [expr $val &   3]
  }

  set rval [format "%02x" $val]

  DebugOut 3 "RETURN: set_pdu_flags $rval"
  return $rval
}

proc readc { len } {
  global global_msg
  DebugOut 8 "CALL: readc $len"

  set rval [string range $global_msg 0 [expr $len-1]]
  set global_msg  [string range $global_msg $len end]

  DebugOut 3 "RETURN: readc '$rval'"
  return $rval
}

############################################
#
# ...the strange pdu stufffffffffffffffffff
#
############################################

proc swap_bytes { num } {
  DebugOut 3 "CALL: swap_bytes $num"

  set rval ""
  set len [string length $num]
  for {set i 0} {$i<$len} {incr i 2} {
    append rval "[string index $num [expr $i+1]][string index $num $i]"
  }

  DebugOut 3 "RETURN: swap_bytes $rval"
  return $rval
} 

proc get_vp_value { pdu vpf } {
  global SMS_MSG_VALID
  DebugOut 3 "CALL: get_vp_value $pdu $vpf"

  set vp ""
  set fmt_str SMS_MSG_VP_VALUE($vpf)
  switch $vpf { 
    ### NO SMS_FLAG(VP) preset
    ### reseved - unused
    $SMS_MSG_VALID(RESERVED) { 
      set vp $fmt_str
    }

    ### "relative" period (integer)
    $SMS_MSG_VALID(RELATIVE) { 
        scan $pdu "%x" val
        if {$val <= 143} {
          set vp [format [lindex $fmt_str 0] [expr ($val+1)*5]]
        } elseif { $val <= 167} {
          set vp [format [lindex $fmt_str 1] [expr 12+($val-143)*0.5]]
        } elseif { $val <= 196} {
          set vp [format [lindex $fmt_str 2] [expr ($val-166)]]
        } else {
          set vp [format [lindex $fmt_str 3] [expr ($val-192)]]
        }
      }
    ### "absolute" period (timestamp)
    $SMS_MSG_VALID(ABSOLUTE) { 
      set vp [format $fmt_str [pdu2time $pdu]]
    }
  }

  DebugOut 3 "RETURN: get_vp_value $vp"
  return $vp 

}

proc read_vp_value { vpf } {
  DebugOut 3 "CALL: read_vp_value"

  switch $vpf {
    0 { ### NO SMS_FLAG(VP) preset
        set vp ""         
    }
    1 { ### reserved - unused - should we call "error"?
        set vp ""         
    } 
    2 { ### "relative" period (integer)
        set vp [readc 2]  
    } 
    3 { ### "absolute" period (timestamp)
        set vp [readc 14] 
    } 
  }

  DebugOut 3 "RETURN: read_vp_value $vp"
  return $vp 
}

proc read_pdu_flags { } {
  global SMS_FLAG PDU_TYPE 
  DebugOut 3 "CALL: read_pdu_flags"

# Service Center Adress
  set SMS_FLAG(SCA) [read_pdu_phone 1]

# Protocol Data Unit
  set SMS_FLAG(PDU) [readc 2]
  scan $SMS_FLAG(PDU) "%x" dec
  set_pdu_flags $dec

# disp_sms_flags
# puts "PDU_TYPE(MTI)=$PDU_TYPE(MTI)"
  switch $PDU_TYPE(MTI) {
    0 { 
      ### SMS-DELIVER
      ### Message Reference
      ### We do NOT GET this value but we 
      ### MUST GENERATE it (e.g. 00) in DELIVER mode
# ??? set SMS_FLAG(MR) [readc 2]
      ### Originator Address
      set SMS_FLAG(OA) [read_pdu_phone 0]
      ### Protocol IDentifier
      set SMS_FLAG(PID) [readc 2]
      ### Data Coding Scheme
      set SMS_FLAG(DCS) [readc 2]
      ### SMS Center Time Stamp
      set SMS_FLAG(SCTS) [readc 14]
# puts "DEBUG: $SMS_FLAG(OA) $SMS_FLAG(PID) $SMS_FLAG(DCS) $SMS_FLAG(SCTS)"
    }
    1 {
      ### SMS-SUBMIT
      ### Message Reference
      ### We do NOT GET this value but we 
      ### MUST GENERATE it (e.g. 00) in DELIVER mode
      set SMS_FLAG(MR) [readc 2]
      ### Destination Address 
      set SMS_FLAG(DA) [read_pdu_phone 0]
      ### Protocol IDentifier
      set SMS_FLAG(PID) [readc 2]
      ### Data Coding Scheme
      set SMS_FLAG(DCS) [readc 2]
      ### Validy Period - returned as explaining string it the moment
      set SMS_FLAG(VP) [read_vp_value $PDU_TYPE(VPF)]
# puts "DEBUG: Gltigkeitsdauer: $ValidPeriod"
    }
    2 {
    ### SMS-COMMAND - reserved
      puts "Message type SMS-COMMAND not supportet!"
      exit 3
    }
    default {
      puts "Invalid PDU_TYPE flag MTI: $PDU_TYPE(MTI)!"
      exit 4
    }
  }

# User Data Length
  set SMS_FLAG(UDL) [readc 2]
  scan $SMS_FLAG(UDL) "%x" len

  DebugOut 3 "RETURN: read_pdu_flags $len"
  return $len
}

proc pdu2phone { pdu } {
  DebugOut 3 "RETURN: pdu2phone $pdu"

  set toa [string range $pdu 0 1]
  set num [swap_bytes [string range $pdu 2 end]]
  set lch [expr [string length $num]-1]
  set lc [string toupper [string index $num $lch]]
  if {$lc == "F"} { set num [string range $num 0 [expr $lch-1]] }
  if {$toa == 91} { set num "+$num" }

  DebugOut 3 "RETURN: pdu2phone $num"
  return $num
}

proc read_pdu_phone { octets } {
  DebugOut 3 "CALL: read_pdu_phone $octets" 

  set hex [readc 2]
  scan $hex "%x" len

# if len is number of octets (SCA only)!!!
  if ($octets) {
    set len [expr ($len-1)*2]
  } else {
    if [expr $len%2] { incr len }
  }

# we read 1 byte TOA and the hex digits
  set pdu [readc [expr $len+2]]

  DebugOut 3 "RETURN: read_pdu_phone $pdu" 
  return $pdu
}

proc time2pdu { year month day hour min zone } {
  DebugOut 3 "CALL: time2pdu $year $month $day $hour $min $zone"

  set dtz [swap_bytes $timestamp]
  if {$zone < 0} { set zone [expr 24+$zone]}
  set d1 [format "%02X" [string range $year 2 3]]
  set d2 [format "%02X" $month]
  set d3 [format "%02X" $day]
  set t1 [format "%02X" $hour]
  set t2 [format "%02X" $min]
  set t3 [format "%02X" $zone]

  set timestamp "$d1$d2$d3$t1$t2$t3"

  set res [swap_bytes $timestamp]

  DebugOut 3 "RETURN: time2pdu $res"
  return $res
}

proc pdu2time { timestamp } {
  DebugOut 3 "CALL: pdu2time $timestamp"

  set dtz [swap_bytes $timestamp]
  set date "20[string range $dtz 0 1]"
  append date ".[string range $dtz 2 3].[string range $dtz 4 5]"
  set time "[string range $dtz 6 7]"
  append time ":[string range $dtz 8 9]:[string range $dtz 10 11]"
  set zone [expr [string range $dtz 12 end]/4]
  if {$zone > 12} {
    set res [list $date $time "-[expr 24-$zone]h" ]
  } else {
    set res [list $date $time [format "+%dh" $zone]]
  }

  DebugOut 3 "RETURN: pdu2time $res"
  return $res
}

proc pdubyte { hnum } {
  DebugOut 3 "CALL: pdubyte $hnum"
  set num "[string index $hnum 1][string index $hnum 0]"
  scan $num "%x" dec

  DebugOut 3 "RETURN: pdubyte $dec"
  return $dec
}

proc phone2pdu { num } {
  DebugOut 3 "CALL: phone2pdu $num"
# bit length byte
#  7   - always 1
#  6-4 - type of number: 001 (international) or 000 (unknown)
#  3-0 - NPI: 0000
# -> 0x91 for international
#    0x81 for unknown (national) numbers
# bugs : no valid digit checking is done (spaces, chars...)
#
  if {"+" == [string index $num 0]} {
    set toa "91"
    set num [string range $num 1 end]
  } else {
    set toa "81"
  }

  set lnu [string length $num]

# if length is odd, then we append a "F"
  if [expr $lnu%2] { append num "F" }

  set res ""
  set len [string length $num]
  for {set i 1} {$i < $len} {set i [expr $i+2]} {
    append res [string index $num       $i   ]
    append res [string index $num [expr $i-1]]
  }

  set rval [format "%02X%s%s" $lnu $toa $res]

  DebugOut 3 "RETURN: phone2pdu $rval"
  return $rval
}

proc txt2pdu { msg } {
  DebugOut 3 "CALL: txt2pdu $msg"
  # bit masks       0   1   2   3   4   5   6   7
  set omask [list 127 126 124 120 112  96  64   0]
  set nmask [list   1   3   7  15  31  63 127 255]
  set out {}
  set i 0

### conversion into the default SMS codes
  set pdu_msg [iso2pdu $msg] 
  set len [string length $pdu_msg]

  while {$i < $len} {
    set bleft [expr $i%8]

### retrieve char[i] from message
    scan [string index $pdu_msg $i] "%c" buffo
### masquerade old byte and shift it right...
    set shfto [expr [expr $buffo & [lindex $omask $bleft]] >> $bleft]

    if {$i == [expr $len-1]} {
      set shftn 0
    } else {
### retrieve char[i+1] from message
      scan [string index $pdu_msg [expr $i+1]] %c" buffn
### masquearde the new byte and shift it left...
      set shftn [expr [expr $buffn & [lindex $nmask $bleft]] << [expr 7-$bleft]]
    }

### the bitwise (shifted_old OR shifted_new) gives the result...
    if {$bleft!=7} {
      set orch [expr $shftn | $shfto]
      lappend out $orch
    }

    incr i
  }
 
### now we convert the integer list to hex...
  set outstr ""
  foreach num $out { append outstr [format "%02X" $num] }

  DebugOut 3 "RETURN: txt2pdu $outstr"
  return $outstr
}

proc pdu2txt { msg udl } {
  DebugOut 3 "CALL: pdu2txt $msg $udl"

  set out {}
  set outstr ""
  set revbyte {}
  set curbyte 0
# bit masks         0   1   2   3   4   5   6
  set nmask [list 127  63  31  15   7   3   1]
  set omask [list 128 192 224 240 248 252 254]

  set lmsg [string length $msg]

### we convert the hex codes into a list of bytes
  for {set i 0} {$i < $lmsg} {incr i 2} { 
    set buffi [string range $msg $i [expr $i+1]]
    scan $buffi "%x" dec
    lappend revbyte $dec
  }
 
  set i 1
  while {[llength $out]<$udl} {
    set bleft [expr $i%7]
    set buffo [lindex $revbyte [expr $i-1]]
    set buffn [lindex $revbyte       $i   ]
    if {$bleft == 1} {
      set byte1 [expr $buffo & [lindex $nmask 0]]
      if {$i == 1} { lappend out $byte1 }
    } 
    set byteo [expr $buffo & [lindex $omask $bleft]]
    set byten [expr $buffn & [lindex $nmask $bleft]]
    set byte1 [expr $byteo >> [expr 8-$bleft]]
    set byte2 [expr $byten <<         $bleft ]
    lappend out [expr $byte1 | $byte2]
     if [expr {$bleft == 6} && {[llength $out]<$udl}] {
      set byteo [expr $buffn & [lindex $omask $bleft]]
       set byte1 [expr $byteo >> 1]
      lappend out $byte1
    } 
    incr i
  }

### now we convert the integer list to pdu chars...
  set str ""
  foreach b $out { append str [format "%c" $b] }
  set outstr [pdu2iso $str]

  DebugOut 3 "RETURN: pdu2txt $outstr"
  return $outstr
}

proc sms_message2txt { pdu } {
  global SMS_FLAG PDU_TYPE global_msg
  DebugOut 3 "CALL: sms_message2txt $pdu"

  if [info exists PDU_TYPE] {unset PDU_TYPE}
  if [info exists SMS_FLAG] {unset SMS_FLAG}

  set global_msg $pdu
  set msglen [read_pdu_flags]
  set txt [pdu2txt $global_msg $msglen]

  DebugOut 3 "RETURN: sms_message2txt $txt"
  return $txt
}

proc sms_message2pdu { pnum msg } {
  global SMS_FLAG PDU_TYPE SMS_DEF 
  DebugOut 3 "CALL: sms_send $pnum $msg"

  if [info exists PDU_TYPE] {unset PDU_TYPE}
  if [info exists SMS_FLAG] {unset SMS_FLAG}

  set SMS_FLAG(SCA) $SMS_DEF(SCA)
  set SMS_FLAG(PDU) [set_pdu_flags -1]
  set SMS_FLAG(MR)  $SMS_DEF(MR)
  set SMS_FLAG(DA)  [phone2pdu $pnum]
  set SMS_FLAG(PID) $SMS_DEF(PID)
  set SMS_FLAG(DCS) $SMS_DEF(DCS)
  set SMS_FLAG(VP)  $SMS_DEF(VP)
  set SMS_FLAG(UDL) [format "%02X" [string length $msg]]

  set pdu ""
  append pdu $SMS_FLAG(SCA)
  append pdu $SMS_FLAG(PDU)
  append pdu $SMS_FLAG(MR)
  append pdu $SMS_FLAG(DA)
  append pdu $SMS_FLAG(PID)
  append pdu $SMS_FLAG(DCS)
  append pdu $SMS_FLAG(VP)
  append pdu $SMS_FLAG(UDL)
  append pdu [txt2pdu $msg]

  DebugOut 3 "RETURN: mdmres $pdu"
  return $pdu
}

###########################################
#
# short message service (SMS) functions
#
############################################
#
# Naming conventions - not fully consistent
#
# q_* ... query value(s)
# r_* ... read values(s)
# s_* ... set, select or write value(s)
#
############################################
# query message format
# param.: none
# result: { fmt1 ... }
#   known formats: 0 - PDU-mode, 1 - ASCII mode
#
proc q_message_format {} {
  set at_cmd "AT+CMGF=?"
  set mdmres [ModemCommand $at_cmd]
  set slist [get_result_list "+CMGF:" [lindex $mdmres 1]]
  return [get_separated_list $slist]
}

############################################
# read message format
# param.: none
# result: format
#   format (see q_message_format)
#
proc r_message_format { } {
  set at_cmd "AT+CMGF?"
  set mdmres [ModemCommand $at_cmd]
  return [lindex $mdmres 1]
}

############################################
# select message format
# param.: format
# result: modem result (OK/ERROR)
#   format (see q_message_format)
#
proc s_message_format { format } {
  set at_cmd "AT+CMGF="
  append at_cmd $format
  set mdmres [ModemCommand $at_cmd]
  return [lindex $mdmres 1]
}

############################################
# query message mode
# param.: none
# result: { 0,1,2,3,4 } (s25) or { from-to } (s35i)
#         { from-to } will be translated to { 0,1,2,3,4 }
#   known modes: 0 - received unread
#                1 - received read
#                2 - stored unsent
#                3 - stored sent
#                4 - all
#
proc q_message_mode {} {
  DebugOut 3 "CALL: q_message_mode"
 
  set at_cmd "AT+CMGL=?"
  set mdmres [ModemCommand $at_cmd]
  set elist [get_result_list "+CMGL:" [lindex $mdmres 1]]
  set slist [get_separated_list $elist]
  set rlist [expand $slist]
  set rval [get_separated_list $rlist]

  DebugOut 3 "RETURN: q_message_mode $rval"
  return $rval
}

############################################
# list short message
# param.: mode
# result: {{ index status alpha length } ...        } if list_only == TRUE
#     or: {{ index status alpha length message } ...} if list_only == FALSE
# or empty string
proc r_message_mode { mode list_only } {
  set at_cmd "AT+CMGL="
  append at_cmd $mode
  set mdmres [ModemCommand $at_cmd]
  set result ""
  if [string compare [lindex $mdmres 1] ""] {
    set result {}
    foreach {res msg} [lrange $mdmres 1 end] {
      set res [get_result_list "+CMGL:" $res]
      if {!$list_only} { append res ",$msg" }
      lappend result [get_separated_list $res]
    }
  }
  return $result
}

############################################
# read short message
# param.: index
# result: { status alpha length message } ...
# or empty string
proc r_message_number { index } {
  set at_cmd "AT+CMGR="
  append at_cmd $index
  set mdmres [ModemCommand $at_cmd]
  set rlist [get_result_list "+CMGR:" "[lindex $mdmres 1],[lindex $mdmres 2]"]
  set rval [get_separated_list $rlist]
  return $rval
} 

############################################
# send short message
# param.: message
# result: ??? some number ????
# bugs  : length of message (max. 160) not checked
proc send_sms_direct { pnum msg } {
  DebugOut 3 "CALL: send_sms_direct $pnum $msg"
 
  set len [string length $msg]
  set pdu [sms_message2pdu $pnum $msg]
  append pdu [format "%c" 0x1a]
 
  set at_cmd "AT+CMGS="
  append at_cmd $len
  append at_cmd "\r\n"
  append at_cmd $pdu
  append at_cmd [format "%c" 0x1a]
# puts "0: at_cmd=$at_cmd" ; exit 0
  set mdmres [ModemCommand $at_cmd]
# puts "1: mdmres=$mdmres"
 
  DebugOut 3 "RETURN: send_sms_direct $[lindex $mdmres 1]"
  return [lindex $mdmres 1]
}

#
# character set functions
#
############################################
#
# query character sets
# param.: none
# result: { charset1 charset2 }
#  char set: GSM     - 7 bit gsm code
#            HEX     - hexadecimal
#            IRA     - international reference alphabet (ITU-T T.50)
#            PCCPxxx - pc code page xxx
#            PCDN    - pc charset dansk/norway
#            UCS2    - ISO unicode (IEC 10646)
#            8859-x  - ISO 8859 latin x (x: 1..6)
#            8859-C  - ISO 8859 latin/cyrillic
#            8859-A  - ISO 8859 latin/arabic
#            8859-G  - ISO 8859 latin/greek
#            8859-H  - ISO 8859 latin/hebrew
proc q_character_set {} {
  set at_cmd "AT+CSCS=?"
  append at_cmd $index
  set mdmres [ModemCommand $at_cmd]
  return [get_result_list "+CPBW:" [lindex $mdmres 1]]
}
 
##############################################################
# select character set
# param.: charset
# result: modem result (OK/ERROR)
#  for known char sets see q_character_set
proc s_character_set { cset } {
  set at_cmd "AT+CSCS="
  append at_cmd $cset
  set mdmres [ModemCommand $at_cmd]
  return [lindex $mdmres 1]
}
