#!/usr/bin/wish
#

source lib/sie_lib.tcl
source lib/gsm_lib.tcl
source lib/sms_lib.tcl

#
# end of user modifyable settingd
#

proc display_msg {msg} {
  set i 0 
  foreach lin $msg { 
    set sl [string length $lin]
    puts "$i: $sl $lin" 
    incr i
  }
}

proc disp_sms { msg } {
  if [lindex $msg 0] {
    puts "[sms_message2txt [lindex $msg 3]]"
    puts "Service Center Address=[pdu2phone $SMS_FLAG(SCA)]"
    if {$PDU_TYPE(MTI)} {
      puts "Gltigkeitsdauer: [get_vp_value $SMS_FLAG(VP) $PDU_TYPE(VPF)]"
      puts "Empfnger: [pdu2phone $SMS_FLAG(DA)]"
    } else {
      puts "Uhrzeit: [pdu2time $SMS_FLAG(SCTS)]"
      puts "Absender: [pdu2phone $SMS_FLAG(OA)]"
    }
    puts [sms_read $pdu]
  }
}

proc disp_pbook { book } {

  global debuglevel

###  set active phone book
# puts "s_phone_books $book"
  set res [s_phone_book $book]

# query  capabilities of active phone book
# puts "q_caps_act_pbook"
  set caps [q_caps_act_pbook]
# display_msg $caps
  set pbk [lindex $caps 0]
  set use [lindex $caps 1]
  set max [lindex $caps 2]
# puts "$book: used $use of $max"

# query phone book contents
# puts "q_pbook_conts $book"
  set conts [q_pbook_conts $book]
# display_msg $conts
  set range [split [lindex $conts 0] "-"]
  set min [lindex $range 0]
  set max [lindex $range 1]
  set lnu [lindex $conts 1]
  set lna [lindex $conts 2]
   puts "range=$min .. $max, l-num=$lnu, l-nam=$lna"

  set max [lindex $range 1 ]
#  puts "r_pbook_entry"
  for { set i $min } { $i <= $use } { incr i } {
    set entry [r_pbook_entry $i]
### display_msg $entry
    set idx [lindex $entry 0]
    set num [lindex $entry 1]
    set cod [lindex $entry 2]
    set nam [pdu2iso [lindex $entry 3]]
###  puts $outf "$pbk\t$idx\t$nam\t$num"
    puts "$book $idx $cod: $num $nam"
  }
}

proc disp_vc_entries { gtc } {
  foreach entr $gtc {
    set typ [lindex $entr 0]
    set mmlist [get_separated_list [expand [lindex $entr 1]]]
    display_msg $mmlist
    if {$typ == "\"vcs\""} {
      foreach mme $mmlist {
  #     puts "r_gtc_entry $typ $mme"
        set res [r_gtc_entry $typ $mme]
        if {[llength $res]>1} {
          display_msg $res
          puts "[lindex $res 0],[lindex $res 1],[lindex $res 2],[lindex $res 3]"
          set cal [lindex $res 4]
          set revbytes ""
          set lcal [string length $cal]
          for {set i 0} {$i < $lcal} {incr i 2} {
            set buffi [string range $cal $i [expr $i+1]]
            scan $buffi "%x" dec
            append revbytes [format "%c" $dec]
          }
          set txt [pdu2iso $revbytes]
          puts $txt
        }
      }
    }
  }
}

proc read_phonelist { pbfile } {
  set fd [open $pbfile r]
  gets $fd lin
  while {![eof $fd]} {
    set flds [split $lin "\t"]
    set book [lindex $flds 0]
    set idx  [lindex $flds 1]
    set name [lindex $flds 2]
    set num  [lindex $flds 3]
    if {![string compare $book SM]} {
      if {[string index $num 0] == "+"} {
        set type 145
      } else {
        set type 129
      }
      set name [iso2pdu $name]
####  s_pbook_entry $idx $num $type $name
### check result
      set entry [r_pbook_entry $idx]
      set idx [lindex $entry 0]
      set num [lindex $entry 1]
      set cod [lindex $entry 2]
      set nam [pdu2iso [lindex $entry 3]]
puts "$book $idx $cod: $num $nam"
    }
    gets $fd lin
  }
  close $fd
}

#################################################################
#                                                               #
#        L E T ' S    S T A R T . . .                           #
#                                                               #
#################################################################

InitDevice $GSM_TTY_DEVICE

puts [ModemCommand "ATZ"]


### puts "complete service provider list"
### puts [ModemCommand "AT^SPLM"]
 
 puts "q_battery_status"
 display_msg [q_battery_status]
      
 puts "q_signal_quality"
 display_msg [q_signal_quality]
  
 puts "q_manufacturer"
 display_msg [q_manufacturer]
 
 puts "q_model_info"
 display_msg [q_model_info]
 
 puts "q_revision_info"
 display_msg [q_revision_info]
 
 puts "q_serial_number"
 display_msg [q_serial_number]
 
 puts "q_sim_imsi"
 display_msg [q_sim_imsi]
 
 puts "q_capabilities"
 display_msg [q_capabilities]
  
 puts "q_phone_books"
 set pbooks [q_phone_books]
 display_msg $pbooks
 
 foreach book $pbooks {
   puts "Telefonbuch: $GSM_PHONE_BOOK([unquote $book])"
#  disp_pbook $book
 }
 
 puts "q_provider_list"
 set slist [q_provider_list]
 display_msg $slist
 
 puts "r_vibrator_state"
 set slist [r_vibrator_state]
 display_msg $slist
 
 puts "q_message_mode"
 set slist [q_message_mode]
 display_msg $slist
 
 foreach mode $slist {
   puts "r_message_mode $mode 0"
   set msg [r_message_mode $mode 0]
   puts "$msg"
   display_msg $msg
 }
 ###################################################################

### SMS stuff
# puts "q_message_mode"
# puts "[q_message_mode]"
# set debuglevel 4
# puts "r_message_mode 4 1"
# set msg [r_message_mode 4 1]
# display_msg $msg
# puts "r_message_mode 1"
# set msg [r_message_number 1]
# display_msg $msg
# disp_sms $msg

## VCalendar entries 
 set debuglevel 4
 puts "q_gtc_entries"
 set gtc [q_gtc_entries]
 display_msg $gtc
 disp_vc_entries $gtc

### read_phonelist phonebook.lst
### disp_pbook SM

CloseDevice
exit 0 
